﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Mod
{
    public class chainBehaviour : MonoBehaviour
    {
        private GameObject hand;
        private AudioSource Audio;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("QuantumBolt.wav");
            handGlow = new GameObject();
            handGlow.transform.parent = hand.transform;
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            LayerMask.GetMask("Objects", "CollidingDebris");
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.gameObject.AddComponent<EMP2>();
	     UnityEngine.Object.Destroy(gameObject);

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
}