﻿using UnityEngine;
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;

namespace Mod
{
    public class handBehaviour : CanShoot
    {

        private GameObject Ruka;
        private PhysicalBehaviour physicalBehaviour;
        private GameObject RukaGlow;
        private Vector2 barrelPosition = new Vector2(0f, 0f);
        private Vector2 barrelDirection = new Vector2(1, 0);
        public bool upgraded = false;
        private LineRenderer laser;
        private LayerMask layers;
        private LayerMask bounds;
        private GameObject components;
        private AudioSource audio;
        private AudioSource Audio;



        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];



        public void Start()
        {
            Ruka = gameObject;
            physicalBehaviour = GetComponent<PhysicalBehaviour>();

            layers = LayerMask.GetMask("Objects", "CollidingDebris", "Bounds");
            bounds = LayerMask.GetMask("Bounds");

            components = new GameObject("components", typeof(Optout));
            components.transform.SetParent(transform);
            components.transform.localPosition = new Vector3(0, 0);
            laser = components.AddComponent<LineRenderer>();
            laser.SetPositions(new[] { Vector3.zero, Vector3.right * 1000 });
            laser.useWorldSpace = false;
            laser.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            laser.sortingLayerName = "Background";
            laser.startColor = new Color(1f, 0f, 0f, 1f);
            laser.endColor = new Color(1f, 0f, 0f, 1f);
            laser.widthMultiplier = 0.1f;
            laser.enabled = false;
            audio = gameObject.GetOrAddComponent<AudioSource>();
            audio.spatialBlend = 0.1f;
            audio.minDistance = 1;
            audio.maxDistance = 2;
            audio.playOnAwake = false;
            audio.loop = false;
            audio.clip = Cyborg.SpartanLaserCharge;
            RukaGlow = new GameObject();
            RukaGlow.transform.parent = Ruka.transform;
            RukaGlow.transform.localPosition = new Vector3(0f, 0f);
            RukaGlow.transform.localScale = gameObject.transform.parent.localScale;
            RukaGlow.transform.localRotation = Quaternion.identity;
            var RukaSprite = RukaGlow.AddComponent<SpriteRenderer>();

            RukaSprite.sprite = ModAPI.LoadSprite("th.png");
            RukaSprite.material = ModAPI.FindMaterial("VeryBright");
            RukaSprite.color = new Color(1f, 0f, 0f, 0f);   
            RukaSprite.sortingLayerName = "Top";


        }
        private void UseContinuous()
        {
           StartCoroutine("LaserDelete");
           audio.Play();
           //audio.PlayOneShot(Cyborg.SpartanLaserCharge);
            Shoot();
        }


        public override void Shoot()
        {
                StartCoroutine(Fire());
        }

    IEnumerator LaserDelete()
    {
        yield return new WaitForSeconds(1f);
        laser.enabled = false;
    }

        private IEnumerator Fire()
        {
            const int iterations = 2;
            const float duration = 0.2f;

            const float interval = duration / iterations;

            laser.startColor = new Color(1f, 0f, 0f, 1f);
            laser.endColor = new Color(1f, 0f, 0f, 1f);
            laser.widthMultiplier = 0.1f;



            laser.enabled = true;
            for (int i = 0; i < iterations; i++)
            {
                var end = Physics2D.Raycast(BarrelPosition, BarrelDirection, 10000, bounds);
                var endPos = end.transform == null ? (Vector3)BarrelPosition + (Vector3)BarrelDirection * 10000 : (Vector3)end.point;
                var victimCount = Physics2D.LinecastNonAlloc(BarrelPosition, endPos, victimBuffer, layers);
                laser.SetPosition(1, components.transform.InverseTransformPoint(endPos));

                for (int n = 0; n < victimCount; n++)
                {
                    var victim = victimBuffer[n];
victim.transform.SendMessage("Break", SendMessageOptions.DontRequireReceiver);
victim.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    ExplosionCreator.CreatePulseExplosion(victim.point, 3f, 2, false);
                    victim.transform.GetComponent<LimbBehaviour>().Frozen = true;
                    victim.transform.GetComponent<SpriteRenderer>().color = new Color(1f, 0f, 0f, 0.15f);
                    var effect = ModAPI.CreateParticleEffect("Disintegration", victim.point);
                    var main = effect.GetComponent<ParticleSystem>().main;main.startColor = new Color(400f, 0f, 0f, 300f);
                    effect.AddComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("timeball.png");
                    victim.transform.GetComponent<PhysicalBehaviour>().InitialMass = -0.005f;
                    victim.transform.GetComponent<PhysicalBehaviour>().TrueInitialMass = -0.005f;
                    GameObject Cyborg;
                    Cyborg = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("íàïðàâîèè").Prefab, victim.point, Quaternion.Euler(0, 0, 0), victim.transform.parent);
                    CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("íàïðàâîèè"), Cyborg);
                    laser.enabled = false;
                    // phys.rigidbody.AddForceAtPosition(forward * DirectionalForce * phys.rigidbody.mass, hit.point, ForceMode2D.Impulse);
                }

                CameraShakeBehaviour.main.Shake(500, transform.position);
                physicalBehaviour.rigidbody.AddRelativeForce(new Vector2(0f * transform.localScale.normalized.x, 0), ForceMode2D.Impulse);
                yield return new WaitForSeconds(interval);
            }
            laser.enabled = false;
            yield return new WaitForSeconds(2.5f);
            laser.enabled = false;
        }










        public override Vector2 BarrelPosition { get { return transform.TransformPoint(barrelPosition); } }

        public Vector2 BarrelDirection { get { return transform.TransformDirection(barrelDirection) * transform.localScale.x; } }


    }
}