﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.IO;
using UnityEngine;
using UnityEngine.Events;

namespace Mod
{
    public class Mod
    {
        public bool IsAutomatic;
        public float AutomaticInterval;
        private AudioSource Audio;
        public float IsBrakeEngaged;
        public float Intensity;
        public GameObject visier;
        public bool Activated;
        public float MotorSpeed;
        private PhysicalBehaviour RC;
        public const float PixelSize = Global.MetricMultiplier / 35f;
        public static void Main()
        {            
            //<color=#ea00ff>
            Cyborg.Initialise();  

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "DeadBud",
                    DescriptionOverride = "Secret! :0",
                    CategoryOverride = ModAPI.FindCategory(""),
                    ThumbnailOverride = ModAPI.LoadSprite("what.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudDeath.png");

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = false;
                        Audio.clip = ModAPI.LoadSound("RootEnd.wav");
                        Audio.Play();

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(0f, 0f, 0f, 1f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -80f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(0f, 0f, 0f, 1f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#00f4ff>CTTC-<color=#ffffff> B.U.D",
                    DescriptionOverride = "ABILITY: Existing (sad moment)",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("Thumb.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(0f, 1f, 1f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 

                        Instance.AddComponent<BudShock>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -80f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(0f, 1f, 1f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";
                        Instance.AddComponent<Off>();
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#ff7000>CTTC-<color=#ffffff> GROWTH B.U.D",
                    DescriptionOverride = "ABILITY: Becomes A Giant BUD For 5.5 Seconds When His Body Is Activated",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb7.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(1f, 0.5f, 0f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 

                        Instance.AddComponent<BudShock>();
                        Instance.AddComponent<BudWakeGrow>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -80f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(1f, 0.5f, 0f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";
                        Instance.AddComponent<Off>();
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#ff00ec>CTTC-<color=#ffffff> JUMPING B.U.D",
                    DescriptionOverride = "ABILITY: Can Jump Very High When His Body Is Activated",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb6.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(1f, 0f, 1f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 

                        Instance.AddComponent<BudShock>();
                        Instance.AddComponent<BudWakeJump>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -80f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(1f, 0f, 1f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";
                        Instance.AddComponent<Off>();
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#3c00ff>CTTC-<color=#ffffff> Gravity Reverse B.U.D",
                    DescriptionOverride = "ABILITY: Can Reverse His Gravity By Activating His Body",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb2.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(0f, 0f, 1f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 

                        Instance.AddComponent<BudShock>();
                        Instance.AddComponent<BudWakeGrav>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -80f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(0f, 0f, 1f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";
                        Instance.AddComponent<Off>();
                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#00ff13>CTTC-<color=#ffffff> SPEED B.U.D",
                    DescriptionOverride = "ABILITY: Got Way More Speed Than The Other BUDs",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb1.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(0f, 1f, 0f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 

                        Instance.AddComponent<BudShock>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        Instance.GetComponent<CarBehaviour>().MotorSpeed = -2000f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        Instance.AddComponent<Off>();
                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(0f, 1f, 0f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#ff0000>CTTC-<color=#ffffff> PULSION B.U.D",
                    DescriptionOverride = "ABILITY: Explodes The Hited Object After Being K.O",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb5.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(1f, 0f, 0f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 
                        Instance.AddComponent<Off>();
                        Instance.AddComponent<BudShockExplode>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -2000f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(1f, 0f, 0f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";

                        Instance.FixColliders();
                    }
                }
            );
            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#d8d8d8>CTTC-<color=#ffffff> ANTI-KO B.U.D",
                    DescriptionOverride = "ABILITY: Is K.O For 0.5 Seconds Instead Of 3.5 Seconds",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb3.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(1f, 1f, 1f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 
                        Instance.AddComponent<Off>();
                        Instance.AddComponent<BudShockKO>();
                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -2000f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;
                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(1f, 1f, 1f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";

                        Instance.FixColliders();
                    }
                }
            );

            ModAPI.Register(
                new Modification()
                {
                    OriginalItem = ModAPI.FindSpawnable("Motorised Wheel"),
                    NameOverride = "<color=#fbff00>CTTC-<color=#ffffff> SHARP WHEEL B.U.D",
                    DescriptionOverride = "ABILITY: Slice Everything The Wheel Touches",
                    CategoryOverride = ModAPI.FindCategory("Entities"),
                    ThumbnailOverride = ModAPI.LoadSprite("thumb4.png"),
                    AfterSpawn = (Instance) =>
                    {
                        Instance.GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudBody.png");

                        var visier = new GameObject();
                        visier.transform.SetParent(Instance.transform);
                        visier.transform.localPosition = new Vector3(0, 0f);
                        visier.transform.localScale = new Vector3(1f, 1f);
                        var visierSprite = visier.AddComponent<SpriteRenderer>();
                        visierSprite.color = new Color(1f, 1f, 0f, 0.05f);
                        visierSprite.sprite = ModAPI.LoadSprite("BudShock.png");
                        visierSprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visierSprite.sortingLayerName = "Top";

                        AudioSource Audio = Instance.AddComponent<AudioSource>();
                        Audio.maxDistance = 1;
                        Audio.loop = true;
                        Audio.clip = ModAPI.LoadSound("BUD.wav");
                        Audio.Play(); 

                        Instance.GetComponent<CarBehaviour>().IsBrakeEngaged = false;
                        //Instance.GetComponent<CarBehaviour>().MotorSpeed = -2000f;
                        Instance.GetComponent<Rigidbody2D>().freezeRotation = false;

                        Instance.GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Ouch.wav")};
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().OverrideImpactSounds = new AudioClip[] {ModAPI.LoadSound("Slicing.wav")};

                        Instance.transform.GetChild(0).GetComponent<SpriteRenderer>().sprite = ModAPI.LoadSprite("BudWheel.png");
                        Instance.transform.GetChild(0).localPosition = new Vector3(0f, -0.4f);
                        Instance.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
                        Instance.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
                        Instance.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
                        Instance.GetComponent<PhysicalBehaviour>().Properties = ModAPI.FindPhysicalProperties("Bulletproof");
                        Instance.transform.GetChild(0).gameObject.AddComponent<BudShockSlice>();
                        Instance.AddComponent<BudShock>();
                        Instance.AddComponent<Off>();

                        var visier2 = new GameObject();
                        visier2.transform.SetParent(Instance.transform.GetChild(0));
                        visier2.transform.localPosition = new Vector3(0, 0f);
                        visier2.transform.localScale = new Vector3(1f, 1f);
                        var visier2Sprite = visier2.AddComponent<SpriteRenderer>();
                        visier2Sprite.color = new Color(1f, 1f, 0f, 0.045f);
                        visier2Sprite.sprite = ModAPI.LoadSprite("WheelShock.png");
                        visier2Sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
                        visier2Sprite.sortingLayerName = "Default";
                        visier2.AddComponent<Glowing>();
                        Instance.FixColliders();
                    }
                }
            );

      }

    public class ArmPower : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {

                            UseEventTrigger useEventTrigger2 = gameObject.AddComponent<UseEventTrigger>();
                            useEventTrigger2.Event = new UnityEvent();
                            useEventTrigger2.Event.AddListener(delegate ()
                             {
                              UnityEngine.Object.Destroy(gameObject.GetComponent<ArmPower>());
                            });

            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("Ouch.wav");
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             gameObject.AddComponent<EMP2>();
             ModAPI.CreateParticleEffect("Zap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
             UnityEngine.Object.Destroy(gameObject.GetComponent<ArmPower>());
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class BudShock : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 8f)
            {
             gameObject.AddComponent<BudWake>();
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class BudShockKO : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 8f)
            {
             gameObject.AddComponent<BudWakeKO>();
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class BudShockSlice : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= -100f)
            {
             other.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("Vapor", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class BudShockExplode : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 5f)
            {
             ExplosionCreator.CreatePulseExplosion(other.transform.position, 4.55f, 2, true);
             gameObject.AddComponent<BudWake>();
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

    public class BudShock2 : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 5f)
            {
             gameObject.AddComponent<BudWake>();
             gameObject.AddComponent<BudShock3>();
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
             UnityEngine.Object.Destroy(gameObject.GetComponent<BudShock>());

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class BudShock3 : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("Ouch.wav");
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 5f)
            {
             gameObject.AddComponent<BudShock4>();
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class BudShock4 : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("Ouch.wav");
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 5f)
            {
             gameObject.AddComponent<BudShockFinal>();
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
             UnityEngine.Object.Destroy(gameObject.GetComponent<BudShock3>());

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }
    public class BudShockFinal : MonoBehaviour
    {
        private AudioSource Audio;
        private GameObject hand;
        private GameObject handGlow;
        private RaycastHit2D[] victimBuffer = new RaycastHit2D[128];
        public void Awake()
        {
            hand = gameObject;
            handGlow = new GameObject();
            handGlow.transform.SetParent(gameObject.transform);
            handGlow.transform.localPosition = new Vector3(0f, 0f);
            handGlow.transform.localScale = gameObject.transform.parent.localScale;

            var handSprite = handGlow.AddComponent<SpriteRenderer>();

            handSprite.sprite = ModAPI.LoadSprite("th.png");
            handSprite.material = ModAPI.FindMaterial("VeryBright");
            handSprite.color = new Color(0f, 0f, 0f, 0f);
            handSprite.sortingLayerName = "Top";

            AudioSource Audio = hand.AddComponent<AudioSource>();
            Audio.loop = false;
            Audio.clip = ModAPI.LoadSound("Ouch.wav");
        }
        public void OnCollisionEnter2D(Collision2D other)
        {
            var rb = hand.GetComponent<Rigidbody2D>();
            if(rb.velocity.magnitude >= 5f)
            {
             gameObject.AddComponent<BudDeath>();
             UnityEngine.Object.Destroy(gameObject.GetComponent<BudShock>());
             UnityEngine.Object.Destroy(gameObject.GetComponent<BudShock4>());
             gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
             ModAPI.CreateParticleEffect("HugeZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
             UnityEngine.Object.Destroy(gameObject.GetComponent<BudShockFinal>());

            }
            else
            {
                other.gameObject.GetComponent<Rigidbody2D>().velocity = rb.velocity * 0;
            }
        }

        public void FixedUpdate()
        {
            if(hand.GetComponent<Rigidbody2D>().velocity.magnitude >= -100f)
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, Mathf.Clamp(gameObject.GetComponent<Rigidbody2D>().velocity.magnitude / 1f, 0f, 1f));
            }
            else
            {
                handGlow.GetComponent<SpriteRenderer>().color = new Color(0f, 0.5f, 1f, 1f);
            }
        }
    }

         public class BudSound : MonoBehaviour 
         {
        private AudioSource audio11112;
        private AudioSource audio111122;
        private AudioSource statio2;
         public GameObject wing;
        private PhysicalBehaviour RC;
         public bool use322;
         public void Awake()
         {
            wing = new GameObject();
            wing.transform.SetParent(gameObject.transform);
            wing.transform.localPosition = new Vector3(0, 0f);
            wing.transform.localScale = new Vector3(1f, 1f);
            var wingSprite = wing.AddComponent<SpriteRenderer>();
            wingSprite.sprite = ModAPI.LoadSprite("BudShock.png");
            wingSprite.material = ModAPI.FindMaterial("Sprites-Default");
            wingSprite.color = new Color(1f, 1f, 1f,1f);
            wingSprite.sortingLayerName = "Top";

            statio2 = gameObject.GetOrAddComponent<AudioSource>();
            statio2.spatialBlend = 0.3f;
            statio2.minDistance = 1;
            statio2.maxDistance = 5;
            statio2.playOnAwake = false;
            statio2.loop = false;
            statio2.clip = ModAPI.LoadSound("Ouch.wav");
            statio2.Play();

         use322 = !use322;
         }

        private void Start()
        {
        RC = gameObject.GetComponent<PhysicalBehaviour>();
            statio2.Play();
        }

         public void Update()
           {
         if (!use322) return;
            statio2.Play();
               }
           }

    public class BudWake : MonoBehaviour
    {
    public void Awake()
    {

         StartCoroutine("Ctt165456645465364566");

    }
    IEnumerator Ctt165456645465364566()
    {
        yield return new WaitForSeconds(0.001f);
        gameObject.transform.GetComponent<PhysicalBehaviour>().Charge = 50;
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
        yield return new WaitForSeconds(4.5f);
        this.gameObject.transform.eulerAngles = new Vector3(0, 0, 0);
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
       // yield return new WaitForSeconds(0.1f);
             //UnityEngine.Object.Destroy(gameObject.GetComponent<BudWake>());
    }
  }

    public class BudWakeKO : MonoBehaviour
    {
    public void Awake()
    {

         StartCoroutine("Ctt165456645465364566");

    }
    IEnumerator Ctt165456645465364566()
    {
        yield return new WaitForSeconds(0.001f);
        gameObject.transform.GetComponent<PhysicalBehaviour>().Charge = 50;
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
        yield return new WaitForSeconds(0.5f);
        this.gameObject.transform.eulerAngles = new Vector3(0, 0, 0);
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
       // yield return new WaitForSeconds(0.1f);
             //UnityEngine.Object.Destroy(gameObject.GetComponent<BudWake>());
    }
  }

    public class BudDeath : MonoBehaviour
    {
        private AudioSource Audio;
    public GameObject wing;
    public void Awake()
    {

         StartCoroutine("Ctt232323232233266666666");

            wing = new GameObject();
            wing.transform.SetParent(this.transform);
            wing.transform.localPosition = new Vector3(0f, 0f);
            wing.transform.localScale = new Vector3(1f, 1f);
            var wingSprite = wing.AddComponent<SpriteRenderer>();
            wingSprite.sprite = ModAPI.LoadSprite("BudDeath.png");
            wingSprite.material = ModAPI.FindMaterial("Sprites-Default");
            wingSprite.color = new Color(1f, 1f, 1f, 1f);
            wingSprite.sortingLayerName = "Top";

    }
    IEnumerator Ctt232323232233266666666()
    {
        yield return new WaitForSeconds(0.001f);
        UnityEngine.Object.Destroy(gameObject.GetComponent<BudShockFinal>());
        ModAPI.CreateParticleEffect("HugeZap", new Vector2(this.transform.position.x, this.transform.position.y));
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 1f;
    }
  }

    public class Glowing : MonoBehaviour
    {
    public void Awake()
    {
         StartCoroutine("Ctt2323232322332666646666");
    }
    IEnumerator Ctt2323232322332666646666()
    {
        yield return new WaitForSeconds(0.001f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.045f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.01f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.045f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.01f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.045f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.01f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.045f);
        yield return new WaitForSeconds(0.685f);
        this.gameObject.AddComponent<SpriteRenderer>().color = new Color(1f, 1f, 0f, 0.01f);
        yield return new WaitForSeconds(0.685f);
        StartCoroutine("Ctt2323232322332666646666");
    }
  }

    public class BudWakeGrav : MonoBehaviour
    {
    public void Use()
    {
         StartCoroutine("Ctt23232323223326666456666");
    }
    IEnumerator Ctt23232323223326666456666()
    {
        yield return new WaitForSeconds(0.001f);
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 0.8f;
        gameObject.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -9.6f;
        yield return new WaitForSeconds(1f);
         gameObject.GetComponent<Rigidbody2D>().freezeRotation = true;
        yield return new WaitForSeconds(3f);
         gameObject.GetComponent<Rigidbody2D>().freezeRotation = false;
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
        gameObject.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
    }
  }

    public class BudWakeJump : MonoBehaviour
    {
    public void Use()
    {
         StartCoroutine("Ctt232323232233266664546666");
    }
    IEnumerator Ctt232323232233266664546666()
    {
        yield return new WaitForSeconds(0.001f);
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -1.5f;
        gameObject.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
        yield return new WaitForSeconds(0.8f);
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
        gameObject.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 16.6f;
        yield return new WaitForSeconds(1f);
        gameObject.GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = -0.5f;
        gameObject.transform.GetChild(0).GetComponent<PhysicalBehaviour>().rigidbody.gravityScale = 6.6f;
    }
  }
    public class BudWakeGrow : MonoBehaviour
    {
    public void Use()
    {
         StartCoroutine("Ctt2323232322332666643546666");
    }
    IEnumerator Ctt2323232322332666643546666()
    {
        yield return new WaitForSeconds(0.001f);
       // gameObject.transform.GetChild(0).localScale = new Vector3(8f, 8f);
        gameObject.transform.localScale = new Vector3(5f, 5f);
        yield return new WaitForSeconds(5.5f);
        //gameObject.transform.GetChild(0).localScale = new Vector3(0.5f, 0.5f);
        gameObject.transform.localScale = new Vector3(1f, 1f);
    }
  }
        public class Off : MonoBehaviour {
         public GameObject off;
         public bool turn;
         void Awake()
         {
         this.GetComponent<PhysicalBehaviour>().ContextMenuOptions.Buttons.Add(new ContextMenuButton("Turn Off", "<color=red>Turn Off", "Turn Off", () =>
         {
          turn = !turn;
          }));
         } 	
         void Update()
         {
        if (!turn) return;
        GameObject Cyborg;
        Cyborg = UnityEngine.GameObject.Instantiate(ModAPI.FindSpawnable("DeadBud").Prefab, gameObject.transform.position, Quaternion.Euler(0, 0, 0));
        CatalogBehaviour.PerformMod(ModAPI.FindSpawnable("DeadBud"), Cyborg);
        gameObject.transform.parent = gameObject.transform.parent;
        gameObject.transform.parent = gameObject.transform;
        Cyborg.transform.position = Cyborg.transform.position;
        Cyborg.transform.parent = Cyborg.transform;
        GameObject.Destroy(gameObject);

            }
        }
    }
  }