﻿using System;
using UnityEngine;

namespace Mod
{
    public class telekBehaviour : MonoBehaviour
    {
        float Recoil = 0.85f;
        float InaccuracyMultiplier = 0f;
        float speed = 1f;
        float damage = 99999999f;
        float ImpactStrength = 50f;
        bool CFME;
        Vector3 pos;
        LayerMask layers;
        public bool createHitDecal = true;
        public bool SpawnExplosionEffect = true;
        private AudioSource Audio1;

        void Awake()
        {
            ModAPI.CreateParticleEffect("BigZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y + -3f));
            gameObject.transform.localScale = new Vector3(7f, 7f);
            gameObject.transform.eulerAngles += new Vector3(0, 0, UnityEngine.Random.value);
            var sprite = gameObject.AddComponent<SpriteRenderer>();
            sprite.sprite = Cyborg.Cttc.PickRandom();
            sprite.color = new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value, 0.25f);
            var eye = ModAPI.CreateLight(gameObject.transform, new Color(UnityEngine.Random.value, UnityEngine.Random.value, UnityEngine.Random.value), 7.5f, 7.5f);
            eye.transform.localPosition = new Vector3(0.04f, 0.1f, 0f);
            sprite.sharedMaterial = ModAPI.FindMaterial("VeryBright");
            layers = LayerMask.GetMask("Objects", "Bounds", "Debris");
            gameObject.SetLayer(9);
            Audio1 = gameObject.AddComponent<AudioSource>();
            Audio1.maxDistance = 5;
            Audio1.loop = false;
            Audio1.clip = ModAPI.LoadSound("tetrisShot.wav");
            Audio1.Play();
            CameraShakeBehaviour.main.Shake(3, transform.position);
        }

        void Update()
        {
            if (CFME)
            {
                return;
            }
            pos = transform.position;
            var dir = transform.right;
            var distance = speed * Time.deltaTime;

            var ray = Utils.MaterialAwareRaycast(pos, dir, distance, layers, 16);

            if (ray.hit.HasValue)
            {
                var hit = ray.hit.Value;
                var hitPhys = ray.physicalBehaviour;

                if (hitPhys && hitPhys.ReflectsLasers)
                {
                    hitPhys.rigidbody.AddForceAtPosition(hit.normal * -ImpactStrength, hit.point, ForceMode2D.Impulse);
                    var newDir = Vector2.Reflect(transform.right, hit.normal);
                    transform.position = hit.point;
                    transform.right = newDir;
                    return;
                }

                if (hitPhys && hitPhys.AbsorbsLasers)
                {
                    ExplosionCreator.CreatePulseExplosion(hit.transform.position, 100f, -1000, true);
                    ExplosionCreator.CreatePulseExplosion(hit.transform.position, 100f, -1000, false);
                    ExplosionCreator.CreatePulseExplosion(hit.transform.position, -1000f, -1000, false);
                    ExplosionCreator.CreatePulseExplosion(hit.transform.position, -1000f, -1000, true);
                    ModAPI.CreateParticleEffect("Spark", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("Spark", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("Spark", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("BrokenElectronicSpark", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("Explosion", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("HugeZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("HugeZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    ModAPI.CreateParticleEffect("HugeZap", new Vector2(gameObject.transform.position.x, gameObject.transform.position.y));
                    transform.position = hit.point;
                    hit.collider.attachedRigidbody.AddForceAtPosition(hit.normal * -ImpactStrength, hit.point);
                    ModAPI.CreateParticleEffect("Explosion", new Vector2(hit.transform.position.x, hit.transform.position.y));
                    hit.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("EMPHit", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("Slice", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("EMPHit", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                    hit.transform.SendMessage("StunImpact", SendMessageOptions.DontRequireReceiver);
                    Impact(hit);
                    return;
                }
            }
            else
            {
                pos += dir * Time.deltaTime * speed;
            }
        }

        private void Impact(RaycastHit2D hit)
        {
            Vector2 normal = hit.normal;
            this.CFME = true;

            float dir = Mathf.Atan2(normal.y, normal.x);
            {
            }

            var physicalBehaviour = hit.collider.GetComponent<PhysicalBehaviour>();

            if (Global.main.PhysicalObjectsInWorldByTransform.TryGetValue(hit.transform, out physicalBehaviour) && physicalBehaviour.SimulateTemperature)
            {
            }

            ExplosionCreator.CreatePulseExplosion(hit.point, ImpactStrength, 30f, SpawnExplosionEffect, true);
        }
    }
}